
# Build a docker image
# variables: DOCKERFILE, IMAGE
.docker-builder:
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - '[ -n "$DOCKERFILE" ] || DOCKERFILE=Dockerfile'
    - '[ -n "$IMAGE" ] || IMAGE="$CI_REGISTRY_IMAGE/builder"'
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile "$CI_PROJECT_DIR/$DOCKERFILE" --destination "$IMAGE"

.docker-wip:
  extends: .docker-builder
  rules:
    # no merge-request dedicated pipelines
    - if: $CI_MERGE_REQUEST_IID
      when: never
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
  variables:
    IMAGE: "$CI_REGISTRY_IMAGE:wip"

.docker-latest:
  extends: .docker-builder
  variables:
    IMAGE: "$CI_REGISTRY_IMAGE:latest"
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

.docker-release:
  extends: .docker-builder
  rules:
    - if: $CI_COMMIT_TAG =~ /^v(\d+)(\.\d+){2}\s*$/
  variables:
    IMAGE: "$CI_REGISTRY_IMAGE:release"
